
package agtweet;

/**
 *
 * @author shauns
 */
public class Tweet {
    private String  _username;
    private String  _contents;

    public String getUsername(){ return _username; }
    public String getContents(){ return _contents; }
    
    public class TweetException extends Exception
    {
        public TweetException(String message) { super(message); }
    }
    
    public Tweet( String name, 
                  String contents, 
                  String errorPrefix ) throws TweetException
    {
        this._username = name;
        this._contents = contents;
        
        boolean tooLong = contents.length() > AGTweet.Config._maxTweetLength;

        if( tooLong )
        {
            switch( AGTweet.Config._largeTweetMode ) 
            {
                case LARGETWEET_SKIP_WITHERROR : {
                    throw new TweetException( errorPrefix + AGTweet.Strings.TWEET_ERR_TOOLONG_SKIP );
                }                
                // no break because of throw
                
                case LARGETWEET_SKIP_SILENT : {
                    throw new UnsupportedOperationException(); //todo: implement silent skipping of large tweets
                }
                // no break because of throw
                
                case LARGETWEET_TRIM_WITHERROR : {
                    throw new UnsupportedOperationException(); //todo: implement verbose trimming of large tweets
                }
                // no break because of throw
                
                case LARGETWEET_TRIM_SILENT : {
                    this._contents = this._contents.substring(0, AGTweet.Config._maxTweetLength);
                }                    
                break;
            }
            
        }
    }
                
}
