
package agtweet;

import java.util.ArrayDeque;
import java.util.Collection;
import java.util.Deque;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Set;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author shauns
 */
public class User implements Comparable<User> {
    private String        _name;
    private Set<String>   _followers;
    private Set<String>   _following;
    private Deque<Tweet> _tweetsToSee;
    private UserList      _userlList;
    
    public  String      getName()                { return _name; }
            Set<String> getFollowers()           { return _followers; }
            Set<String> getFollowing()           { return _following; }
            boolean     isFollowing(String name) { return _following.contains(name); }
    
    private User()
    {
        _followers   = new HashSet<String>();
        _following   = new HashSet<String>();
        _tweetsToSee = new ArrayDeque<Tweet>();
    }
    
    User(String name)
    {
        this();
        _name      = name;
    }
    
    Queue<Tweet> getTweetsToSee()
    {
        return _tweetsToSee;
    }
    
    void AddFollower(String newFollowerName)
    {
        _followers.add(newFollowerName);
    }
    
    void AddFollowing(String newFollowingName)
    {
        _following.add(newFollowingName);
    }

    void AddFollowing(Set<String> newFollowingNames)
    {
        for(String newFollowingName : newFollowingNames )
        {
            _following.add(newFollowingName);
        }
    }
    
    void RecieveTweet(Tweet t)
    {
        _tweetsToSee.addLast(t);
    }
            
    void PublishTweet(Tweet t, UserList ul)
    {
        for( String u : _followers  )
        {
            try {
                ul.getUser(u).RecieveTweet(t);
            } catch (UserList.UserListException ex) {
                Logger.getLogger(AGTweet.LOGNAME).log(Level.WARNING, AGTweet.Strings.USER_TWEETERROR, ex);
            }
        }
    }
    
    @Override
    public int compareTo(User otherUser) {
        return _name.compareTo(otherUser._name);
    }
}
